link-vmlinux.sh 5.6 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225
  1. #!/bin/sh
  2. #
  3. # link vmlinux
  4. #
  5. # vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
  6. # $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
  7. # in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
  8. # Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
  9. #
  10. # vmlinux
  11. # ^
  12. # |
  13. # +-< $(KBUILD_VMLINUX_INIT)
  14. # | +--< init/version.o + more
  15. # |
  16. # +--< $(KBUILD_VMLINUX_MAIN)
  17. # | +--< drivers/built-in.o mm/built-in.o + more
  18. # |
  19. # +-< ${kallsymso} (see description in KALLSYMS section)
  20. #
  21. # vmlinux version (uname -v) cannot be updated during normal
  22. # descending-into-subdirs phase since we do not yet know if we need to
  23. # update vmlinux.
  24. # Therefore this step is delayed until just before final link of vmlinux.
  25. #
  26. # System.map is generated to document addresses of all kernel symbols
  27. # Error out on error
  28. set -e
  29. # Nice output in kbuild format
  30. # Will be supressed by "make -s"
  31. info()
  32. {
  33. if [ "${quiet}" != "silent_" ]; then
  34. printf " %-7s %s\n" ${1} ${2}
  35. fi
  36. }
  37. # Link of vmlinux.o used for section mismatch analysis
  38. # ${1} output file
  39. modpost_link()
  40. {
  41. ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
  42. --start-group ${KBUILD_VMLINUX_MAIN} --end-group
  43. }
  44. # Link of vmlinux
  45. # ${1} - optional extra .o files
  46. # ${2} - output file
  47. vmlinux_link()
  48. {
  49. local lds="${objtree}/${KBUILD_LDS}"
  50. if [ "${SRCARCH}" != "um" ]; then
  51. ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
  52. -T ${lds} ${KBUILD_VMLINUX_INIT} \
  53. --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
  54. else
  55. ${CC} ${CFLAGS_vmlinux} -o ${2} \
  56. -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
  57. -Wl,--start-group \
  58. ${KBUILD_VMLINUX_MAIN} \
  59. -Wl,--end-group \
  60. -lutil ${1}
  61. rm -f linux
  62. fi
  63. }
  64. # Create ${2} .o file with all symbols from the ${1} object file
  65. kallsyms()
  66. {
  67. info KSYM ${2}
  68. local kallsymopt;
  69. if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
  70. kallsymopt=--all-symbols
  71. fi
  72. kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
  73. if [ -n "${CONFIG_X86_64}" ]; then
  74. kallsymopt="${kallsymopt} --absolute-percpu"
  75. fi
  76. local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
  77. ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
  78. ${NM} -n ${1} | \
  79. scripts/kallsyms ${kallsymopt} | \
  80. ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
  81. }
  82. # Create map file with all symbols from ${1}
  83. # See mksymap for additional details
  84. mksysmap()
  85. {
  86. ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
  87. }
  88. # Delete output files in case of error
  89. trap cleanup SIGHUP SIGINT SIGQUIT SIGTERM ERR
  90. cleanup()
  91. {
  92. rm -f .old_version
  93. rm -f .tmp_System.map
  94. rm -f .tmp_kallsyms*
  95. rm -f .tmp_version
  96. rm -f .tmp_vmlinux*
  97. rm -f System.map
  98. rm -f vmlinux
  99. rm -f vmlinux.o
  100. }
  101. #
  102. #
  103. # Use "make V=1" to debug this script
  104. case "${KBUILD_VERBOSE}" in
  105. *1*)
  106. set -x
  107. ;;
  108. esac
  109. if [ "$1" = "clean" ]; then
  110. cleanup
  111. exit 0
  112. fi
  113. # We need access to CONFIG_ symbols
  114. . ./.config
  115. #link vmlinux.o
  116. info LD vmlinux.o
  117. modpost_link vmlinux.o
  118. # modpost vmlinux.o to check for section mismatches
  119. ${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
  120. # Update version
  121. info GEN .version
  122. if [ ! -r .version ]; then
  123. rm -f .version;
  124. echo 1 >.version;
  125. else
  126. mv .version .old_version;
  127. expr 0$(cat .old_version) + 1 >.version;
  128. fi;
  129. # final build of init/
  130. ${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
  131. kallsymso=""
  132. kallsyms_vmlinux=""
  133. if [ -n "${CONFIG_KALLSYMS}" ]; then
  134. # kallsyms support
  135. # Generate section listing all symbols and add it into vmlinux
  136. # It's a three step process:
  137. # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
  138. # but __kallsyms is empty.
  139. # Running kallsyms on that gives us .tmp_kallsyms1.o with
  140. # the right size
  141. # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
  142. # the right size, but due to the added section, some
  143. # addresses have shifted.
  144. # From here, we generate a correct .tmp_kallsyms2.o
  145. # 3) That link may have expanded the kernel image enough that
  146. # more linker branch stubs / trampolines had to be added, which
  147. # introduces new names, which further expands kallsyms. Do another
  148. # pass if that is the case. In theory it's possible this results
  149. # in even more stubs, but unlikely.
  150. # KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
  151. # other bugs.
  152. # 4) The correct ${kallsymso} is linked into the final vmlinux.
  153. #
  154. # a) Verify that the System.map from vmlinux matches the map from
  155. # ${kallsymso}.
  156. kallsymso=.tmp_kallsyms2.o
  157. kallsyms_vmlinux=.tmp_vmlinux2
  158. # step 1
  159. vmlinux_link "" .tmp_vmlinux1
  160. kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
  161. # step 2
  162. vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
  163. kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
  164. # step 3
  165. size1=$(stat -c "%s" .tmp_kallsyms1.o)
  166. size2=$(stat -c "%s" .tmp_kallsyms2.o)
  167. if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
  168. kallsymso=.tmp_kallsyms3.o
  169. kallsyms_vmlinux=.tmp_vmlinux3
  170. vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
  171. kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
  172. fi
  173. fi
  174. info LD vmlinux
  175. vmlinux_link "${kallsymso}" vmlinux
  176. info SYSMAP System.map
  177. mksysmap vmlinux System.map
  178. # step a (see comment above)
  179. if [ -n "${CONFIG_KALLSYMS}" ]; then
  180. mksysmap ${kallsyms_vmlinux} .tmp_System.map
  181. if ! cmp -s System.map .tmp_System.map; then
  182. echo Inconsistent kallsyms data
  183. echo echo Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
  184. cleanup
  185. exit 1
  186. fi
  187. fi
  188. # We made a new kernel - delete old version file
  189. rm -f .old_version